diff --git a/pkgs/default.nix b/pkgs/default.nix
index 47097878338995200bf9b5cb737b51baa4f3a716..8f62db6d22638fa55ccbd1a87a0a597ec3844d8e 100644
--- a/pkgs/default.nix
+++ b/pkgs/default.nix
@@ -361,6 +361,7 @@     gaiagpsclient = callPackage ./misc/gaiagpsclient { };
     git-tui = callPackage ./misc/git-tui { };
     goto = callPackage ./misc/goto { };
     graphene = callPackage ./misc/graphene { };
+    headscale-webui = callPackage ./misc/headscale-webui { };
     heapusage = callPackage ./misc/heapusage { };
     how-to-use-pvs-studio-free = callPackage ./misc/how-to-use-pvs-studio-free { };
     huami-token = callPackage ./misc/huami-token { };
diff --git a/pkgs/misc/headscale-webui/default.nix b/pkgs/misc/headscale-webui/default.nix
new file mode 100644
index 0000000000000000000000000000000000000000..cd01b4070d3f2b264279fa9f5769903ac81e5b10
--- /dev/null
+++ b/pkgs/misc/headscale-webui/default.nix
@@ -0,0 +1,57 @@
+{
+  lib,
+  stdenv,
+  fetchFromGitHub,
+  nodejs_20,
+  pnpm_9,
+}:
+
+stdenv.mkDerivation (finalAttrs: {
+  pname = "headscale-webui";
+  version = "0.0.5";
+
+  src = fetchFromGitHub {
+    owner = "jamebal";
+    repo = "headscale-webui";
+    tag = "v${finalAttrs.version}";
+    hash = "sha256-IDWrGXJG18j4xpDxE/w/wmRrK6wY+ykV4aeshKboK8Q=";
+  };
+
+  patches = [ ./pnpm-lock.yaml.patch ];
+
+  pnpmDeps = pnpm_9.fetchDeps {
+    inherit (finalAttrs)
+      pname
+      version
+      src
+      patches
+      ;
+    hash = "sha256-2aERyYmvkRh9A8rCTYRcNccn7431+02amu5a/VMwKt4=";
+  };
+
+  nativeBuildInputs = [
+    nodejs_20
+    pnpm_9.configHook
+  ];
+
+  buildPhase = ''
+    runHook preBuild
+    pnpm run build:prod
+    runHook postBuild
+  '';
+
+  installPhase = ''
+    runHook preInstall
+    mkdir $out
+    cp -R dist $out
+    runHook postInstall
+  '';
+
+  meta = {
+    description = "Tailscale-compatible orchestration server web front-end for headscale";
+    homepage = "https://github.com/jamebal/headscale-webui";
+    license = lib.licenses.mit;
+    maintainers = [ lib.maintainers.sikmir ];
+    skip.ci = true;
+  };
+})
